
// ITCSCAN2DemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ITCSCAN2Demo.h"
#include "ITCSCAN2DemoDlg.h"
#include "itcscan2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

INT32 g_handle = 0;
CListBox *pMyListBox;	//listbox handle
CButton *pBtn;			//checkbox button	
CEdit *pEditCtrl;		//edit control box

// CITCSCAN2DemoDlg dialog

CITCSCAN2DemoDlg::CITCSCAN2DemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CITCSCAN2DemoDlg::IDD, pParent)
	, m_editPreamble(_T(""))
	, m_editPostamble(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CITCSCAN2DemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_PREAMBLE, m_editPreamble);
	DDX_Text(pDX, IDC_EDIT_POSTAMBLE, m_editPostamble);
}

BEGIN_MESSAGE_MAP(CITCSCAN2DemoDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_SET, &CITCSCAN2DemoDlg::OnBnClickedButtonSet)
	ON_BN_CLICKED(IDC_BUTTON_CLEAN, &CITCSCAN2DemoDlg::OnBnClickedButtonClean)
	ON_BN_CLICKED(IDC_BUTTON_EXIT, &CITCSCAN2DemoDlg::OnBnClickedButtonExit)
END_MESSAGE_MAP()


void GetBarcodeData(INT32 msgData)
{
    DWORD BytesReturned = 0;
    DWORD iSymbologyID = 0;
    DWORD iDataType = 0;
    DWORD iPortID = 0;

	BYTE scannedData[2018];
	memset(scannedData, 0, sizeof(scannedData));

	TCHAR SymbologyName[256];
	memset(SymbologyName, 0, sizeof(SymbologyName));

	TCHAR PortName[50];
	memset(PortName, 0, sizeof(PortName));

	TCHAR PortDeviceType[50];
	memset(PortDeviceType, 0, sizeof(PortDeviceType));

	ITCSCAN_GetScannedDataValues(msgData, 
								scannedData, 
								&BytesReturned, 
								&iDataType, 
								&iSymbologyID, 
								SymbologyName, 
								&iPortID, 
								PortName, 
								PortDeviceType);

	if(BytesReturned > 0)
	{
		TCHAR dataBuf[2048] = {0};
		CString wData;

		scannedData[BytesReturned] = 0;
		wData = (CString)scannedData;

		//display barcode data
		wsprintf(dataBuf, _T("Barcode = %s"),wData);
		pMyListBox->AddString(dataBuf);

		//display buffer size
		wsprintf(dataBuf, _T("ByteInBuffer = %d"),BytesReturned);
		pMyListBox->AddString(dataBuf);		

		//display buffer size
		wsprintf(dataBuf, _T("DataType = %d"),iDataType);
		pMyListBox->AddString(dataBuf);

		//symbologyID
		wsprintf(dataBuf, _T("SymbologyID = %d"),iSymbologyID);
		pMyListBox->AddString(dataBuf);

		//SymbologyName
		wsprintf(dataBuf, _T("SymbologyName = %s"), SymbologyName);
		pMyListBox->AddString(dataBuf);

		//Port ID
		wsprintf(dataBuf, _T("PortID = %d"), iPortID);
		pMyListBox->AddString(dataBuf);

		//Port name
		wsprintf(dataBuf, _T("PortName = %s"), PortName);
		pMyListBox->AddString(dataBuf);

		//Port device type
		wsprintf(dataBuf, _T("PortDeviceType = %s"), PortDeviceType);
		pMyListBox->AddString(dataBuf);

		//space
		wsprintf(dataBuf, _T("================"));
		pMyListBox->AddString(dataBuf);

		pMyListBox->SetCurSel(pMyListBox->GetCount() - 1);
	}
}

void GetScanError(INT32 msgData)
{
	TCHAR dataBuf[256] = {0};

	//display port ID
	wsprintf(dataBuf, _T("ErrorCode = %x"),msgData);
	pMyListBox->AddString(dataBuf);

	if(msgData == E_ITCADC_RESPONSE_TOO_BIG )
	{
		wsprintf(dataBuf, _T("ErrorMessge = E_ITCADC_RESPONSE_TOO_BIG"));
		pMyListBox->AddString(dataBuf);
	}
}

void GetNotificationData(INT32 msgData)
{
	DWORD PortID = 0;
    DWORD PortStateID = 0;

	TCHAR portName[ITC_DEVICE_TYPE_MAXLEN];
	memset(portName, 0, sizeof(portName));

	TCHAR deviceType[ITC_DEVICE_TYPE_MAXLEN];
	memset(deviceType, 0, sizeof(deviceType));

	TCHAR PortStateName[ITC_DEVICE_TYPE_MAXLEN];
	memset(PortStateName, 0, sizeof(PortStateName));

	ITCSCAN_GetNotificationValues(msgData, &PortID, portName, deviceType, &PortStateID, PortStateName);

	if(PortID > 0)
	{
		TCHAR dataBuf[256] = {0};

		//display port ID
		wsprintf(dataBuf, _T("PortID = %d"),PortID);
		pMyListBox->AddString(dataBuf);

		//display port name
		wsprintf(dataBuf, _T("portName = %ls"),portName);
		pMyListBox->AddString(dataBuf);

		//display deviceType
		wsprintf(dataBuf, _T("deviceType = %s"),deviceType);
		pMyListBox->AddString(dataBuf);

		//dispaly PortStateID
		wsprintf(dataBuf, _T("PortStateID = %d"),PortStateID);
		pMyListBox->AddString(dataBuf);

		//display port state name
		wsprintf(dataBuf, _T("PortStateName = %s"),PortStateName);
		pMyListBox->AddString(dataBuf);

		//space
		wsprintf(dataBuf, _T("================"));
		pMyListBox->AddString(dataBuf);

		pMyListBox-> SetCurSel(pMyListBox->GetCount() - 1);
	}
}

HRESULT SetConfig(BYTE gid, BYTE fid, BYTE inValue)
{
	HRESULT hrStatus = 0;

	DWORD commandSize = 3;
	BYTE inpCommand[3];

	//set command buffer
	inpCommand[0] = gid;
	inpCommand[1] = fid;
	inpCommand[2] = inValue;

	hrStatus = ITCSCAN_SetConfigInfo(g_handle, inpCommand,  commandSize);

	return hrStatus;
}

HRESULT GetConfig(BYTE gid, BYTE fid, BYTE retBuffer[], DWORD *retBufferSize)
{
	HRESULT hrStatus = 0;

	DWORD commandSize = 2;
	BYTE inpCommand[2];

	//set command buffer
	inpCommand[0] = gid;
	inpCommand[1] = fid;
	
	hrStatus = ITCSCAN_GetConfigInfo(g_handle, inpCommand, commandSize, retBuffer, retBufferSize);	

	return hrStatus;
}

DWORD WINAPI ReadThread(LPVOID *pHandle)
{
	TCHAR dataBuf[2048] = {0};

	HRESULT hStatus = 0;
	ITCSCAN_MESSAGE_TYPE msgType;
	INT32 msgData = -1;

	while((hStatus == 0) && (g_handle != 0))
	{
		hStatus = ITCSCAN_GetBarcodeMessage(g_handle, &msgType, &msgData);

		if(hStatus != 0)
		{
			break;
		}

		switch (msgType)
		{			
			case MSG_BARCODEDATA_READ:				//barcode data
				GetBarcodeData(msgData);
				break;
			case MSG_BARCODEDATA_ERROR:
				GetScanError(msgData);				//get error code and message
				break;
			case MSG_SCANNER_NOTIFY:
				//GetNotificationData(msgData);		//scanner notifcation
				break;				
		}
	}	

	return (DWORD)hStatus;
}

HRESULT SetConfigString(BYTE gid, BYTE fid, CString inStr)
{
	HRESULT hrStatus;
	DWORD commandSize = 0;
	BYTE inCommand[20];
	memset(inCommand, 0, sizeof(inCommand));

	inCommand[0] = gid;
	inCommand[1] = fid;
	inCommand[2] = 0x00;
	
	//get length of input string
	int strLen = inStr.GetLength();
	inCommand[3] = strLen;

	//converts the wide-character string pointed to by string into the multibyte array pointed to by dest
	//store bytes in command buffer start index 4
	wcstombs((char *) &inCommand[4], inStr, strLen);
	
	//get total comand size
	commandSize = strLen + 4;
	
	hrStatus = ITCSCAN_SetConfigInfo(g_handle, inCommand, commandSize);

	return hrStatus;
}

HRESULT GetConfigString(BYTE gid, BYTE fid, TCHAR dataBuf[])
{
	HRESULT hrStatus;
	BYTE retBuffer[1024];
	DWORD retBufferSize = -1;
	memset(retBuffer, 0, sizeof(retBuffer));

	hrStatus = GetConfig(gid, fid, retBuffer, &retBufferSize);

	if(SUCCEEDED(hrStatus) && retBufferSize > 0)
	{
		int retValueLen = retBuffer[3];

		mbstowcs( dataBuf, (const char *)&retBuffer[4], retValueLen);
		dataBuf[retValueLen] = TEXT('\0');
	}
	else
	{
		hrStatus = -1;
	}

	return hrStatus;
}


// CITCSCAN2DemoDlg message handlers

BOOL CITCSCAN2DemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	HRESULT hrStatus;	

	//set the listbox control handle
	pMyListBox = (CListBox *)GetDlgItem(IDC_LIST_BARCODE_DATA);	

	HCURSOR prevCursor = SetCursor(AfxGetApp()->LoadStandardCursor(IDC_WAIT));

	//get handle for Internal scanner
	hrStatus = ITCSCAN_Open(&g_handle, L"External", 2048);

	if(!SUCCEEDED(hrStatus))
	{
		MessageBox(_T("Scanner open error"), _T("Error"), MB_OK);
	}
	else
	{
		//create a barcode read thread with ExtScanner scanner
		DWORD dwChildThreadId;
		HANDLE tempThreadHandle = CreateThread((LPSECURITY_ATTRIBUTES)NULL,
									(DWORD)0,
									(LPTHREAD_START_ROUTINE)ReadThread,
									(LPVOID) &g_handle,
									(DWORD)0,
									(LPDWORD) &dwChildThreadId);

		//enable read barcode
		BOOL PostRead = TRUE;
		ITCSCAN_SetPostRead(g_handle, PostRead);

		TCHAR dataBuf[2048] = {0};		
		BYTE retBuffer[1024];
		DWORD retBufferSize = -1;
		memset(retBuffer, 0, sizeof(retBuffer));

		//get code39 enable status
		hrStatus = GetConfig(0x42, 0x40, retBuffer, &retBufferSize);
		if(retBufferSize > 2)
		{
			pBtn = (CButton*)GetDlgItem(IDC_CHECK_CODE39);
			if(retBuffer[2] == 0x01)
			{
				pBtn->SetCheck(1);
			}
			else
			{
				pBtn->SetCheck(0);
			}
		}

		//get code128 enable status
		hrStatus = GetConfig(0x43, 0x40, retBuffer, &retBufferSize);
		if(retBufferSize > 2)
		{
			pBtn = (CButton*)GetDlgItem(IDC_CHECK_CODE128);

			if(retBuffer[2] == 0x01)
			{
				pBtn->SetCheck(1);
			}
			else
			{
				pBtn->SetCheck(0);
			}
		}

		//get Interleaved 2 of 5 enable status
		hrStatus = GetConfig(0x44, 0x40, retBuffer, &retBufferSize);
		if(retBufferSize > 2)
		{
			pBtn = (CButton*)GetDlgItem(IDC_CHECK_I2OF5);
			if(retBuffer[2] == 0x01)
			{
				pBtn->SetCheck(1);
			}
			else
			{
				pBtn->SetCheck(0);
			}
		}

		//get PDF417 enable status
		hrStatus = GetConfig(0x4C, 0x40, retBuffer, &retBufferSize);
		if(retBufferSize > 2)
		{
			pBtn = (CButton*)GetDlgItem(IDC_CHECK_PDF417);
			if(retBuffer[2] == 0x01)
			{
				pBtn->SetCheck(1);
			}
			else
			{
				pBtn->SetCheck(0);
			}
		}

		//get current Preamble setting
		hrStatus = GetConfigString(0x60, 0xC0, dataBuf); 
		if(SUCCEEDED(hrStatus))
		{
			m_editPreamble = (CString)dataBuf;
		}

		//get current Postamble string
		hrStatus = GetConfigString(0x60, 0xC1, dataBuf); 
		if(SUCCEEDED(hrStatus))
		{
			m_editPostamble = (CString)dataBuf;
		}

		//cause the changed data to be displayed
		UpdateData(FALSE);

		//set current cursor
		SetCursor(prevCursor);	
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CITCSCAN2DemoDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CITCSCAN2DemoDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CITCSCAN2DemoDlg::OnBnClickedButtonSet()
{
	HRESULT hrStatus = 0;
	
	TCHAR dataBuf[2048] = {0};
	CString wData;

	
	// Enable/disable code 39
	if(IsDlgButtonChecked(IDC_CHECK_CODE39))
	{
		hrStatus = SetConfig(0x42, 0x40, 0x01);
	}
	else
	{
		hrStatus = SetConfig(0x42, 0x40, 0x00);
	}
	
	// Enable/disable code128
	if(IsDlgButtonChecked(IDC_CHECK_CODE128))
	{
		hrStatus = SetConfig(0x43, 0x40, 0x01);
	}
	else
	{
		hrStatus = SetConfig(0x43, 0x40, 0x00);
	}
	
	// Enable/disable Interleaved I 2 Of 5
	if(IsDlgButtonChecked(IDC_CHECK_I2OF5))
	{
		hrStatus = SetConfig(0x44, 0x40, 0x01);
	}
	else
	{
		hrStatus = SetConfig(0x44, 0x40, 0x00);
	}

	// Enable/disable PDF417
	if(IsDlgButtonChecked(IDC_CHECK_PDF417))
	{
		//enable PDF417
		hrStatus = SetConfig(0x4C, 0x40, 0x01);
	}
	else
	{
		//diable PDF417
		hrStatus = SetConfig(0x4C, 0x40, 0x00);
	}

	//set preamble
	pEditCtrl = (CEdit *)GetDlgItem(IDC_EDIT_PREAMBLE);
	pEditCtrl->GetWindowTextW(m_editPreamble);
	hrStatus = SetConfigString(0x60, 0xC0, m_editPreamble);

	//set postamble	
	pEditCtrl = (CEdit *)GetDlgItem(IDC_EDIT_POSTAMBLE);
	pEditCtrl->GetWindowTextW(m_editPostamble);
	hrStatus = SetConfigString(0x60, 0xC1, m_editPostamble);
	
	if(!SUCCEEDED(hrStatus))
	{
		wsprintf(dataBuf, _T("failed on setting"));
		pMyListBox->AddString(dataBuf);		
	}	
	else
	{
		wsprintf(dataBuf, _T("Done setting"));
		pMyListBox->AddString(dataBuf);		
	}

	wsprintf(dataBuf, _T("================"));
	pMyListBox->AddString(dataBuf);	

	pMyListBox-> SetCurSel(pMyListBox->GetCount() - 1);
}

void CITCSCAN2DemoDlg::OnBnClickedButtonClean()
{
	//remove items from listbox
	pMyListBox->ResetContent();
}

void CITCSCAN2DemoDlg::OnBnClickedButtonExit()
{
	if(g_handle != 0)
	{
		//close itcscan to release resource
		ITCSCAN_Close(g_handle);

		Sleep(500);		
	}

	//close the dialog
	CDialog::OnCancel();
}
